% :- type bfa ---> ures ; bfa(int, bfa, bfa).

% beszur(BF0, E, BF): E beszrsa BF0 rendezett fba
%                     a BF rendezett ft adja
% :- pred beszur(bfa::in, int::in, bfa::out).
beszur(ures, Elem, bfa(Elem, ures, ures)).
beszur(BF0, Elem, BF):-
        BF0 = bfa(E,B,J),  % az indexels mkdik!
        (   Elem = E -> BF = BF0
        ;   Elem < E -> BF = bfa(E,B1,J),
            beszur(B, Elem, B1)
        ;   BF = bfa(E,B,J1),
            beszur(J, Elem, J1)
        ).

% lista_bfa(L, BF0, BF): L elemeit beszrva BF0-ba
% kapjuk BF-t.
% :- pred lista_bfa(list(int)::in, bfa::in, bfa::out).
lista_bfa([], BF, BF).
lista_bfa([E|L], BF0, BF):-
        beszur(BF0, E, BF1),
        lista_bfa(L, BF1, BF).

% bfa_lista(BF, L0, L): A BF fa levelei az L-L0 listt adjk.
% :- pred bfa_lista(bfa::in, list(int)::in, list(int)::out).
bfa_lista(ures, L, L).
bfa_lista(bfa(E, B, J), L0, L):-
        bfa_lista(J, L0, L1),
        bfa_lista(B, [E|L1], L).

% L lista rendezettje R.
% :- pred rendez(list(int)::in, list(int)::out).
rendez(L, R):-
        lista_bfa(L, ures, BF), bfa_lista(BF, [], R).

