:- ensure_loaded(time).

% app(L1, L2, L3): Az L3 lista az L1 s L2 listk elemeinek 
% egyms utn fzsvel ll el.
app([], L, L).
app([X|L1], L2, [X|L3]) :-
    app(L1, L2, L3).

% nrev(L, R): Az R lista az L megfordtsa --- nav megolds.
nrev([], []).
nrev([X|L], R) :-
    nrev(L, RL),
    app(RL, [X], R).

% app(L1, L2, L3): Az L3 lista az L1 s L2 listk elemeinek 
% egyms utn fzsvel ll el. Felesleges call/1 hvst hasznl.
app2([], L, L).
app2([X|L1], L2, [X|L3]) :-
    call(app2(L1, L2, L3)).


% nrev2(L, R): Az R lista az L megfordtsa --- nav megolds.
% Felesleges call/1 hvst hasznl.
nrev2([], []).
nrev2([X|L], R) :-
    nrev2(L, RL),
    app2(RL, [X], R).

% mk_list(N, L): L az N, N-1, ..., 1 elemekbl ll lista.
mk_list(0, L) :- !, L = [].
mk_list(N, [N|L]) :-
	N1 is N-1, mk_list(N1, L).

% A call/1 kltsgt mr pldafuts
time_call :-
	mk_list(1414, L),
	consult(call_koltsege),
	time('call-lal, interpretlva:   ', nrev2(L, _), IC),
	time('call nlkl, interpretlva:', nrev(L, _), I),
	ILassulas is IC/I,
	format('                            lassuls   = ~2f~n', [ILassulas]),
	compile(call_koltsege),
	time('call-lal, lefordtva:      ', nrev2(L, _), CC),
	time('call nlkl, lefordtva:   ', nrev(L, _), C),
	CLassulas is CC/C,
	format('                            lassuls   = ~2f~n', [CLassulas]).
	     
% between(M, N, I): M =< I =< N, I egsz.
% Elfelttel: M =< N.
between(M, _N, M).
between(M, N, I) :-
        M < N, 
        M1 is M+1,
        between(M1, N, I).

control_bips :-
	(   between(1, 1000000, _), fail
	;   true
	).

	
% A  vezrlsi beptett eljrsok (konjunkci, diszjunkci)
% kltsgt mr pldafuts (BIP = built-in predicate).
time_control_bips :-
	consult(call_koltsege),
	Goal = 	(   between(1, 1000000, _), fail
                ;   true
                ),
	time('interpretlva:         ', control_bips),
	time('meta eljrssal, int.: ', Goal),
	compile(call_koltsege),
	time('lefordtva:            ', control_bips),
	time('meta eljrssal, ford.:', Goal).



