% fib(N, F): F az N. Fibonacci-szer szm.
% Determinisztikus.
fib(1, 1).
fib(2, 2).
fib(N, F) :-
        N > 2,
        N2 is N*3//4,
        N3 is N*2//3,
        fib(N2, F2),
        fib(N3, F3),
        F is F2+F3.

% fibc(N, F): F az N. Fibonacci-szer szm.
% Determinisztikus lefuts.
fibc(1, 1) :- !.
fibc(2, 2) :- !.
fibc(N, F) :-
        N > 2,
        N2 is N*3//4,
        N3 is N*2//3,
        fibc(N2, F2),
        fibc(N3, F3),
        F is F2+F3.

% fibci(N, F): F az N. Fibonacci-szer szm.
% Visszalpsmentes (indexels folytn).
fibci(1, F) :- !, F = 1.
fibci(2, F) :- !, F = 2.
fibci(N, F) :-
        N > 2,
        N2 is N*3//4,
        N3 is N*2//3,
        fibci(N2, F2),
        fibci(N3, F3),
        F is F2+F3.

time_fib :-
	(   fib(2000, _), fail
	;   time('fib', fib(2000,_)),
	    time('fibc', fibc(2000,_)),
	    time('fibci', fibci(2000,_))
	).

% Kirja Goal megoldsainak ellltshoz s a meghisulshoz
% szksges idt, a Txt szveg kisretben.
time(Txt, Goal) :-
	statistics(runtime, _), 
	(   call(Goal), Res = megolds
	;   Res = meghisuls
	),
	statistics(runtime, [_,T]), % T az elz statistics hvs ta 
	                            % eltelt CPU id, msec-ban.
	statistics,
	statistics(trail, [TrailUsed,_]),
	format('~w ~w ~t~18|futsi ideje = ~3d sec, nyom = ~|~t~3d~8+ Kbyte\n',
	       [Txt,Res,T,TrailUsed]), 
	statistics(runtime, _),
	Res = meghisuls.

