:-use_module(library(lists), [append/3]).


:- meta_predicate call(:, ?), call(:, ?, ?),
	call(:, ?, ?, ?), call(:, ?, ?, ?).
 
% Pred az A utols argumentummal meghvva igaz.
call(M:Pred, A) :- 
        Pred =.. FAs0,
	append(FAs0, [A], FAs1), 
        Pred1 =.. FAs1,
	call(M:Pred1).

% Pred az A s B utols argumentumokkal meghvva igaz.
call(M:Pred, A, B) :- 
        Pred =.. FAs0,
	append(FAs0, [A,B], FAs2), 
        Pred2 =.. FAs2,
	call(M:Pred2).

% Pred az A, B s C utols argumentumokkal meghvva igaz.
call(M:Pred, A, B, C) :- 
        Pred =.. FAs0,
	append(FAs0, [A,B,C], FAs3), 
        Pred3 =.. FAs3,
	call(M:Pred3).

% Pred az A, B, C s D utols argumentumokkal meghvva igaz.
call(M:Pred, A, B, C, D) :- 
        Pred =.. FAs0,
	append(FAs0, [A,B,C,D], FAs4), 
        Pred4 =.. FAs4,
	call(M:Pred4).

% map(Xs, Pred, Ys): Az Xs lista elemeire a Pred transzformcit
% alkalmazva kapjuk az Ys listt.
map([X|Xs], Pred, [Y|Ys]) :-
        call(Pred, X, Y),
	map(Xs, Pred, Ys).
map([], _, []).

% foldl(+Xs, :Pred, +Y0, -Y): Y0-bl indulva, az Xs elemeire balrl jobbra
% sorra alkalmazva a Pred ltal lert ktargumentum fggvnyt kapjuk Y-t.
foldl([X|Xs], Pred, Y0, Y) :-              
        call(Pred, X, Y0, Y1),
	foldl(Xs, Pred, Y1, Y).            
foldl([], _, Y, Y).                        

% foldr(+Xs, :Pred, +Y0, -Y): Y0-bl indulva, az Xs elemeire jobbrl balra
% sorra alkalmazva a Pred ktargumentum fggvnyt kapjuk Y-t.
foldr([X|Xs], Pred, Y0, Y) :-            
        foldr(Xs, Pred, Y0, Y1),
	call(Pred, X, Y1, Y).           
foldr([], _, Y, Y).                      


% Pldk:

ngyzete(X, Y) :- Y is X*X.

jegyhozz(Alap, Jegy, Szam0, Szam) :- Szam is Szam0*Alap+Jegy.   

proba :-
	map([1,2,3,4], ngyzete, NL),
	write(NL), nl,
	foldl([1,2,3], jegyhozz(10), 0, L),
	write(L), nl,
	foldr([1,2,3], jegyhozz(10), 0, R),
	write(R), nl.

