% nrev(L, DR): Az L lista megfordtsa a DR klnbsglista.
nrev_dl([], L-L).               % L-L \(\equiv\) res klnbsglista
nrev_dl([X|L], DR) :-
    app_dl(DR0, [X|T]-T, DR),   % [X|T]-T \(\equiv\) egyelem klnbsglista
    nrev_dl(L, DR0).

% app_dl(DL1, DL2, DL3): DL1 s DL2 klnbsglistk sszefzse DL3.
app_dl(L-L0, L0-L1, L-L1).

% Az L lista megfordtsa R
rev(L, R) :-
	nrev_dl(L, R-[]).

% Az L lista megfordtsa R
rev2(L, R) :-
	rev2(L, [], R).

% rev2(L, R0, R): Az L lista megfordtsa az R-R0 klnbsglista
% rev2(L, R0, R) \(\equiv\) nrev_dl(L, R-R0).
rev2([], L, L).
rev2([X|L], R0, R) :-
	R = R2, R1 = [X|R0],
	rev2(L, R1, R2).

% Az L lista megfordtsa R
rev3(L, R) :-
	rev3(L, [], R).

% rev3(L, R0, R): Az L lista megfordtsa az R-R0 klnbsglista
% rev3(L, R0, R) \(\equiv\) nrev_dl(L, R-R0).
rev3([], L, L).
rev3([X|L], R0, R) :-
	rev3(L, [X|R0], R).

	

:- use_module(time).

list(0, L) :- !, L = [].
list(N, [N|L]) :-
	N1 is N-1, list(N1, L).

test :-
	list(1000000, L),
	(   time('nrev_dl', rev(L, _)), fail
	;   time('rev2   ', rev2(L, _)), fail
	;   time('rev3   ', rev3(L, _))
	).

