% T1 megelzi T2-t a szabvnyos sorrendben (T1 @< T2)
% (A vltozk rendezse az  elfordulsi sorrend szerint trtnik.)
precedes(T1, T2) :- 
        \+ \+ (numbervars1(T1-T2, 0, _), prec(T1, T2)).

% T1 megelzi T2-t, a vltozk mr '$myvar'(n) konstansokra vannak lecserlve.
prec(T1, T2) :- 
        class(T1, C1), class(T2, C2),
        (   C1 =:= C2 ->
            (   C1 =:= 1 -> T1 < T2   % 4. szably (lebegpontos szm)
            ;   C1 =:= 2 -> T1 < T2   % 4. szably (egsz szm)
            ;   struct_prec(T1, T2)   % 3., 5. s 6. szably
            )                         % (vltoz, nv, struktra)
        ;   C1 < C2                   % 2. szably
        ).

% class(+T, -C): A T kifejezs a C-edik kifejezsosztlyba tartozik.
class(T, C) :- 
        ( /*vlt*/ T='$myvar'(_) -> C=0
        ; /*szm*/ float(T) ->      C=1        
        ;          integer(T) ->    C=2            
        ; /*atom*/ atom(T) ->       C=3        
        ; /*struktra*/             C=4        
        ).                                         

% S1 megelzi S2-t (struktra-kifejezsekre s atomokra).
struct_prec(S1, S2) :- 
	functor(S1, F1, N1), functor(S2, F2, N2),
	(   N1 < N2 -> true
        ;   N1 = N2, 
	    (   F1 = F2 -> args_prec(1, N1, S1, S2)
            ;   atom_prec(F1, F2)                  
            )                                      
        ).

% Az S1 struktra-kifejezs N0, ..., N sorszm argumentumai
% lexikografikusan megelzik S2 azonos sorszm argumentumait.
args_prec(N0, N, S1, S2) :- 
	N0 =< N, arg(N0, S1, A1), arg(N0, S2, A2),
    	(   A1 = A2 -> N1 is N0+1, args_prec(N1, N, S1, S2)
    	;   prec(A1, A2)
    	).

% A1 atom megelzi A2 atomot.
atom_prec(A1, A2) :-
    atom_codes(A1, C1), atom_codes(A2, C2), struct_prec(C1, C2).
