% sum(+L, ?S): Az L szmlista elemeinek sszege S.
sum([], 0).
sum([X|L], S):- sum(L,S0), S is S0+X.

% sum1(+L, +S): Az L szmlista elemeinek sszege S.
sum1([], 0).
sum1([X|L], S) :- /* S is S0+X helyett: */ S0 is S-X, sum1(L, S0).

% sum2(+L): Az L szmlista elemeinek sszegt kirja.
sum2(L):- sum2(L, 0).

% sum2(+L, +S0): Az L lista S0-lal nvelt sszegt kirja.
sum2([], S) :-    write(S), nl.
sum2([X|L], S0):- S1 is S0+X, sum2(L, S1).

% sum3(+L, ?S): Az L szmlista elemeinek sszege S.
sum3(L, S):- sum3(L, 0, S).

% sum3(+L, +S0, ?S): Az L lista elemeit hozzadva S0-hoz kapjuk S-et.
sum3([], S, S).
sum3([X|L], S0, S):-
        S1 is S0+X, sum3(L, S1, S).

:- use_module(time).

list(0, L) :- !, L = [].
list(N, [1|L]) :-
	N1 is N-1, list(N1, L).

test :-
	list(1000000, L),
	(   time('sum ', sum(L, _)), fail
	;   time('sum3', sum3(L, _))
	).
